//Exam #3 Question 4

import java.util.ArrayList;

public class SkiSlope
{
  /** The altitudes of locations on the slope */
  private int[][] alts;

  /********************* Part (a) *********************/

  /** Returns the index of the element in the top row of alts
   *  that holds the greatest value of all the alts values in
   *  the top row.
   */
  public int summitLocation()
  {
    int iMax = 0;

    for (int i = 1; i < alts[0].length; i++)
    {
      if (alts[0][i] > alts[0][iMax])
        iMax = i;
    }
    return iMax;
  }

  /********************* Part (b) *********************/

  /** Builds and returns the "steepest trail" on the slope.
   *  The trail starts at the summit, in the top row. On each
   *  step, the trail proceeds to the neighboring location
   *  just below the current location or the one diagonally
   *  to the left or to the right (if available), always
   *  choosing the location with the lowest altitude. (If the
   *  altitude in two or three neighboring locations is the
   *  same, any one of them may be chosen.) Returns an
   *  ArrayList<Integer> that holds the indices of locations
   *  on the trail in consecutive rows, starting at the summit.
   */
  public ArrayList<Integer> findSteepestTrail()
  {
    ArrayList<Integer> trail = new ArrayList<Integer>();

    int col = summitLocation();
    trail.add(col);

    for (int row = 1; row < alts.length; row++)
    {
      int nextCol = col;
      if (col > 0 && alts[row][col-1] < alts[row][nextCol])
        nextCol = col - 1;

      if (col < alts[0].length - 1 &&
                     alts[row][col+1] < alts[row][nextCol])
        nextCol = col + 1;

      col = nextCol;
      trail.add(col);
    }
    return trail;
  }

  /*********************  Extra  *********************/

   /** Returns the indices of the first and last occurences 
    *  of the largest value in the array arr.
    */
  public static int[] leftAndRightMax(int[] arr)
  {
    ...
  }

  /** Builds and returns the "zigzag trail" on the slope.
   *  The trail starts at the summit in the top row and
   *  proceeds down from one row to the next, ending
   *  at a location in the bottom row.  On each step, the
   *  trail proceeds to the location with the greatest altitude
   *  in the next row, alternating the leftmost and the rightmost
   *  maximum in consecutive rows.
   */
  public ArrayList<Integer> findZigzagTrail()
  {
    ...
  }

  /********************** Test **********************/

  public static void main(String[] args)
  {
    int[][] alts = {
      {7, 9, 6, 9},
      {8, 9, 9, 8},
      {6, 5, 5, 6},
      {4, 6, 3, 5},
      {5, 5, 4, 3},
      {2, 2, 3, 1},
      {2, 1, 0, 1}};

    SkiSlope test = new SkiSlope();
    test.alts = alts;
    
    ArrayList<Integer> trail = test.findSteepestTrail();
    System.out.println(trail);
    
    trail = test.findZigzagTrail();
    System.out.println(trail);
  }
}
