// Exam #5 Question 1

public class Cipher
{
  private static final String ABC = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

  /********************* Part (a) *********************/
  
  /** Returns a new string in which each letter in text is
   *  replaced with the letter whose index in abc is equal
   *  to the index of the original letter plus key, with
   *  wraparound, if needed, back to the beginning of abc.
   *  All the characters in text that are not letters remain
   *  unchanged.
   *  // Precondition: all letters in text are uppercase;
   *  // (Modify to handle lowercase letters)
   *                0 < key < 26.
   */
  public static String encrypt(String text, int key)
  {
    String code = "";
    for (int i = 0; i < text.length(); i++)
    {
      String letter = text.substring(i, i+1);
      int j = ABC.indexOf(letter);
      if (j >= 0)
      {
        j = (j + key) % 26;  // The index of the substitute
                             //   letter
        code += ABC.substring(j, j+1);
      }
      else
        code += letter;
    }
    return code;
  }

  /********************* Part (b) *********************/
  
  /** Returns a new string in which each letter in code is
   *  replaced with the letter whose index in abc is equal
   *  to the index of the letter minus key, with
   *  wrap-around at index 0.
   *  Precondition: All letters in code are uppercase;
   *                0 < key < 26
   */
  public static String decrypt(String code, int key)
  {
    return encrypt(code, 26 - key);
  }

  /*********************  Extra  *********************/

  /** Encode text using Vigenere cipher */
  public static String vigenereEncrypt(String text, String key)
  {
    ...
  }

  /** Decode code using Vigenere cipher */
  public static String vigenereDecrypt(String code, String key)
  {
    ...
  }
}