// Exam #5 Question 4

public class MovieTheater
{
  /********************* Part (a) *********************/

  /** Returns the number of vacant seats in the "desirable"
   *  area of the seats array: the h rows starting from row 2
   *  and the w contiguous seats in the center of each row.
   *  Precondition: The entire "desirable" area fits within
   *                the seats array; w and the number of seats
   *                in each row are even numbers.
   */
  public static int vacantGoodSeats(boolean[][] seats, int w, int h)
  {
    int count = 0;
    
    for (int r = 2; r <= 1 + h; r++)
      for (int c = (seats[0].length - w)/2; c < (seats[0].length + w)/2; c++)
        if (seats[r][c] == false)
          count++;

    return count;
  }

  /********************* Part (b) *********************/

  /** Returns the location of a pair of vacant seats closest
   *  to the central pair of seats. The central pair is
   *  in the middle of the center row; if the number of rows
   *  is even, the "center" row is the one closer to the
   *  screen. The location of a pair of seats is defined
   *  as the row and column of the left seat in the pair
   *  (the seat with the smaller column index). Returns
   *  null if a pair of adjacent vacant seats is not found.
   */
  public static Location bestTwoSeats(boolean[][] seats)
  {
    Location center = new Location((seats.length - 1)/2, seats[0].length/2 - 1);
    Location bestLocation = null;

    for (int r = 0; r < seats.length; r++)
    {
      for (int c = 0; c < seats[0].length - 1; c++)
      {
        if (!(seats[r][c] || seats[r][c+1]))
        {
          Location loc = new Location(r, c);
          if (bestLocation == null || loc.distanceFrom(center) < bestLocation.distanceFrom(center))
            bestLocation = loc;
        }
      }
    }
    return bestLocation;
  }
}